config/routes.rb
Rails.application.routes.draw do

namespace :admin do
  resources :participants do
    post 'reset', on: :member
  end
  resources :communities do
    resources :participants
  end
  resources :organizations
  resources :ressources
end

scope :path => '/sys', :as => 'sys' do
  resources :memberships, :only => [:index]
  resources :events, :only => [:index] do
    match :fifo, :via => [:get, :post], :on => :collection
  end
  resources :configs, :only => [:index, :create]
  resources :subparticipants, :only => [:index, :show, :create, :update, :destroy]
end

begin
  Ressource.all.each do |r|
    scope :path => "/#{r.namespace}", :as => r.namespace  do
      resources r.ressource.to_sym, :controller => :messages, :only => [:index, :show, :create, :update, :destroy] do
        match :fifo, :via => [:get, :post], :on => :collection
        match :lifo, :via => [:get, :post], :on => :collection
        match :details, :via => [:get], :on => :collection
        match :details, :via => [:get], :on => :member
      end
    end
  end
rescue ActiveRecord::StatementInvalid
  Rails.logger.info "DB error: #{$!}"
end

resources :memberships, :only => [:index]
resources :events, :only => [:index] do
  match :fifo, :via => [:get, :post], :on => :collection
end

get '/admin' => 'admin/participants#index'
root 'admin/participants#default'

end

app/models/community.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
#
# This file is part of ECS.
#
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


class Community < ApplicationRecord
  has_many  :memberships, -> { order 'memberships.id ASC' }
  has_many  :participants, :through => :memberships
  has_many :community_messages, :dependent => :destroy
  has_many :messages, :through => :community_messages
  validates_presence_of :name
  validates_uniqueness_of :name

  scope :for_participant, lambda { |participant|
    joins(:memberships => :participant).
    where(:participants => { :id => participant.id })}

  scope :for_message, lambda { |message|
    joins(:memberships => {:membership_messages => :message}).
    where(:messages => { :id => message.id })}

end

app/controllers/admin/communities_controller.rb
# Copyright (C) 2017 Heiko Bernloehr (FreeIT.de).
#
# This file is part of ECS.
#
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
#
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


class Admin::CommunitiesController < ApplicationController

  include Admin::Helper

  # TODO verify http methods

  def index
    list
    render :action => 'list'
  end

  def list
    if ECS_CONFIG["participants"]["allow_anonymous"]
      @communities=Community.all.distinct
    else
      @communities=Community.all.where.not(name: "public").distinct
    end
  end

  def show
    @community = Community.find(params[:id])
  end

  def new
    @community = Community.new
  end

  def create
    @community = Community.new(community_params)
    if @community.save
      flash[:notice] = 'Community was successfully created.'
      redirect_to admin_community_path(@community)
    else
      render :action => 'new'
    end
  end

  def edit
    @community = Community.find(params[:id])
  end

  def update
    @community = Community.find(params[:id])
    if @community.update(community_params)
      flash[:notice] = 'Community was successfully updated.'
      redirect_to admin_community_path(@community)
    else
      render :action => 'edit'
    end
  end

  def destroy
    Community.find(params[:id]).destroy
    redirect_to admin_communities_path
  end

  # lists all participants of the community
  def index_participants
    @community = Community.find(params[:id])
    @participants=Community.find(params[:id]).memberships.collect {|i| i.participant  }.distinct.sort{|x,y| x.id <=> y.id }
  end

  # lists all those participants which has not joined the community
  def index_nonparticipants
    index_participants
    @participants=(Participant.all - @participants).sort{|x,y| x.id <=> y.id }
  end

  # community releases a participant
  def destroy_participant
    destroy_membership(params[:id], params[:p_id])
    redirect_to admin_community_participants_path(:id=>params[:id])
  end

  # community invites a participant
  def create_participant
    create_membership(params[:id], params[:p_id])
    redirect_to index_admin_community_nonparticipants_path(:id=>params[:id])
  end

private

  def community_params
    params.require(:community).permit(:name, :description)
  end


end

app/helpers/admin/communities_helper.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
# 
# This file is part of ECS.
# 
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
# 
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


module Admin::CommunitiesHelper
end

app/views/admin/communities/_form.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->

<% if @community.errors.any? %>
  <div id="error_explanation">
    <h2><%= pluralize(@community.errors.count, "error") %> prohibited
      this Community from being updated</h2>
    <ul>
      <% @community.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<p><label for="community_name" class="box2 table-resource-label">Name:</label>
<%= form.text_field :name %></p>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label for="community_description" class="table-resource-label">Description (optional):</label>
</div>
<%= form.text_area :description, :rows => 2 , :style => "width:99.5%" %>
</div>
</div>

app/views/admin/communities/edit.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Edit Community</h1>

<p>
<%= link_to 'Show', admin_community_path(@community) %> |
<%= link_to 'Back', admin_communities_path %>
</p>

<p>
<%= form_for [:admin, @community], :method=>:put do |form| %>
  <p><%= form.submit 'Save' %></p>
  <%= render :partial => form %>
  <p><%= form.submit 'Save' %></p>
<% end %>
</p>

<p>
<%= link_to 'Show', admin_community_path(@community) %> |
<%= link_to 'Back', admin_communities_path %>
</p>

app/views/admin/communities/index_nonparticipants.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1>Listing Participants to join Community "<%= @community.name+" ("+@community.description+")" %>" </h1>

<%= link_to 'Back', index_admin_communities_path %><BR><BR>

<%= render(:partial => 'shared/admin/participants',
           :locals  => 
           {  
             :links => 
             [
               { 
                 :text=>"join Community", 
                 :map_name_function=>'create_admin_community_participant_path(:id => @community.id, :p_id => participant.id), :method=>:post'
               }
             ]
           }
          ) 
%>

<BR><%= link_to 'Back', index_admin_communities_path %><BR>

app/views/admin/communities/index_participants.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1>Listing Participants of Community "<%= @community.name+" ("+@community.description+")" %>" </h1>

<%= link_to 'Back', index_admin_communities_path %><BR><BR>

<%= render(:partial => 'shared/admin/participants',
           :locals  => 
           {  
             :links => 
             [
               { 
                 :text=>"release Participant", 
                 :map_name_function=>'destroy_admin_community_participant_path(:id => @community.id, :p_id => participant.id), :method=>:delete, :confirm => \'Are you sure?\''
               }
             ]
           }
          ) 
%>

<BR><%= link_to 'Back', index_admin_communities_path %><BR>

app/views/admin/communities/list.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Listing Communities</h1>

<%= link_to 'New community', new_admin_community_path %>

<p>

<table class="list">

  <TR class="table-resource-label">
  <TH class="box2">Id</TH>
  <TH class="box2">&uarr; Name</TH>
  <TH class="box2">Description (optional)</TH>
  <TH class="box2" align="center">Operations</TH>
  </TR>
  <tr></tr>
  
  <% for community in @communities.sort{|x,y| x.name.downcase <=> y.name.downcase}.each %>
  	<tr valign="top" class="<%= cycle('list-line-odd', 'list-line-even') %>">
      <TD> <%= community.id %></TD>
  		<TD> <%= h community.name %> </TD>
      <TD> <%= h truncate(community.description,:length => 80) %> </TD>
      <TD>
  			<%= link_to 'Show', admin_community_path(:id => community) %>
  			<%= link_to 'Edit', edit_admin_community_path(:id => community) %>
  			<%= link_to 'Destroy', admin_community_path(:id => community), :confirm => 'Are you sure?', :method => :delete %><BR>
  		</TD>
    </tr>
  <% end %>

</table>

</p>

app/views/admin/communities/new.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">New Community</h1>

<p>
<%= link_to 'Back', admin_communities_path %>
</p>

<p>
<%= form_for [:admin, @community], :method => :post  do |form| %>
  <p><%= form.submit "Create" %></p>
  <%= render :partial => form %>
  <p><%= form.submit "Create" %></p>
<% end %>
</p>

<p>
<%= link_to 'Back', admin_communities_path %>
</p>

app/views/admin/communities/show.html.haml
-#
  Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012 Heiko Bernloehr (FreeIT.de).
  
  This file is part of ECS.
  
  ECS is free software: you can redistribute it and/or modify it
  under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of
  the License, or (at your option) any later version.
  
  ECS is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Affero General Public License for more details.
  
  You should have received a copy of the GNU Affero General Public
  License along with ECS. If not, see <http://www.gnu.org/licenses/>.


%h1.box1 Show Community

%p
  = link_to 'Edit', edit_admin_community_path(:id => @community)
  |
  = link_to 'Back', admin_communities_path

.normal-skip
  %span.box5
    %label.box2.table-resource-label(for="community_name") Name:
    = h @community.name

- unless @community.description.blank?
  %p
    .formular-input-width.table-border
      .table-header
        %label.table-resource-label Description (optional):
      = @community.description.gsub(/\r\n/, '<BR>')

- unless (participants= Participant.for_community(@community)).blank?
  %p
    .show-output-width.table-border
      .table-header
        %label.table-resource-label Participants joining the community:
    
      %table.list(width="100%")
        %tr(align="left")
          %th ID:
          %th Name:
          %th Description:
          %th(align="right") MembershipID (mid):
        - participants.each do |participant|
          %tr{:class => [cycle('list-line-odd', 'list-line-even')]}
            %td= link_to h(participant.id), admin_participant_path(participant)
            %td= participant.name
            %td= h(participant.description).gsub(/\r\n/, '<BR>')
            %td(align="right")= participant.mid(@community)

%p
  = link_to 'Edit', edit_admin_community_path(:id => @community)
  |
  = link_to 'Back', admin_communities_path